;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
; File Notes:
; 1. This file contains the "_main" routine. The run-time C start-up library
;    will bring code execution to the label "_main" after initializing
;    data RAM.
; 2. All sub-routines are called from this file.
;
; LAB 3 Instructions:
; 1. Fill in the missing source code in the "lab3_part1.s" file.
; 2. Build the project, program the device and run by unplugging the ICD2
;    header (ICD2 in Programmer Mode)
; 3. Press switches S1-S4 to see various clock switching sequences in action.
; 4. Press switch S2 to switch to the FRC source and then disconnect the
;    primary external clock(EC) input, EC. Next, press S1 to attempt switching
;    to the EC and note your observations. Does the device switch to clock that
;    not present?
; 5. Power down the board and reconnect the external clock input (EC)
; 6. Add the "lab3_part2.s" file to the MPLAB project.
; 7. Fill in the missing source code in the "lab3_part2.s" file.
; 8. Build the project, program the device and run by unplugging the ICD2
;    header (ICD2 in Programmer Mode)
; 9. Disconnect the External Clock input to the device. Does the device stop
;    functioning? If not, then what oscillator source is the device using?
;
;..............................................................................
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab3.inc"             ;Lab-specific global equates

                                        ;Config Macros to program configuration
                                        ;words
                                        ;More example macros are provided in
                                        ;the device include file, p30f6014.inc
        config __FOSC, CSW_FSCM_ON & EC_PLL8
        config __FWDT, WDT_OFF
        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_64 & MCLR_EN
        config __FGS, CODE_PROT_OFF

                                        ;Provide global definitions
        .global _main
        .global __AddressError, __StackError    ;Provide global scope to the
                                        ;Address and Stack Error Trap handlers
                                        ;The linker will place the address of
                                        ;the routines in the Interrupt Vector
                                        ;Table (IVT)

        .section .text                  ;Places source code in Code section
_main:                                  ;C-run-time start-up library brings you
                                        ;here after initializing RAM variables

        rcall   _init_SPI2              ;Call SPI2 initialaization routine

        rcall   _init_LCD_Controller    ;Call the LCD Controller initialization
                                        ;routine

        rcall   lab3_init               ;Call routine to initialize port D pins
                                        ;and Timer2

        rcall   lab3_part1              ;Call routine to initialize external
                                        ;interrupt pins

L0:     nop
        bra     L0



;...
;Trap Handler Routines:
;1. Address Error Trap
;2. Stack Error Trap
;...

__AddressError:                         ;Address Error trap Routine
        nop                             ;Code execution reaches here if
        bra     $-2                     ;incorrect addresses are accessed
                                        ;in Data memory or Program memory
        bclr    INTCON1, #ADDRERR       ;Example clearing of the trap flag
        retfie                          ;Return from trap handler

__StackError:                           ;Stack Error trap Routine
        nop                             ;Code execution reaches here if
        bra     $-2                     ;a stack underflow or overflow occurred
        bclr    INTCON1, #STKERR        ;Example clearing of the trap flag
        retfie                          ;Return from trap handler


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        .end                                            ;EOF



