;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
; File Notes:
; 1. The SPI2 module is configured to communicate with the PIC18F242
;    on the expansion board. The 18F242 will control the LCD on the
;    expansion board.
;
;END_HEADER


	.include "p30f6014.inc"

	.global _init_SPI2		;Provide global scope to routine
	.section .text			;Places source code in Code section

_init_SPI2:

        push w0

        bset LATG, #LATG9       	;Configure RG9 to be slave select
        bclr TRISG, #TRISG9     	;signal for selecting PIC18f242

        clr SPI2STAT
        mov #0x001A, w0
        mov w0, SPI2CON         	;Master Clk = Fcy/16 (using primary 
                                	;and secondary prescalers)

        bclr SPI2CON, #SMP      	;Input data sampled at middle of output time
        bclr SPI2CON, #CKE      	;data clocked out on rising edge

        bclr SPI2CON, #CKP      	;CLK idle is low
        bset SPI2CON, #MSTEN    	;SPI2 in Master mode

        bclr SPI2STAT, #SPIROV  	;Clear any overflow errors
        bset IPC6, #SPI2IP2
        bclr IPC6, #SPI2IP1
        bset IPC6, #SPI2IP0

        bclr IFS1, #SPI2IF      	;Clear the interrupt flag bit
        bclr IEC1, #SPI2IE      	;Disable SPI2 ISR processing for now

        bset SPI2STAT, #SPIEN   	;Enable SPI2 

        pop w0
	
	return				;Return to calling routine
	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.end					;EOF

