;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
; File Notes:
; 1. This file contains the "_main" routine. The run-time C start-up library
;    will bring code execution to the label "_main" after initializing
;    data RAM.
; 2. All sub-routines are called from this file.
;
; LAB 4 - Part 1 Instructions:
;
; 1. Short pin RD7 to RD13, so that the PWM signal generated by the
;    OC8 module may serve as an input to the Input Capture-6 module.
;
; 2. Fill in the missing source code in the "lab4_part1" routine. Refer to
;    lab4_part1.s file in project window.
;
; 3. Fill in the missing source code in the interrupt service routine -
;    named "__IC6Interrupt". Refer to lab4_part1.s file in project
;    window.
;
; 4. Build the project and program the device and run.
;
; 5. Tweak the potentiometer, RP1, and observe the frequency
;    output on the LCD
;
; LAB 4 - Part 2 Instructions:
;
; 1. Short pin RD7 to RD13, so that the PWM signal generated by the
;    OC8 module may serve as an input to the Input Capture-6 module.
;
; 2. Add the file, lab4_part2.s, into the MPLAB project.
;
; 3. Fill in the missing source code in the "lab4_part2" routine. Refer to
;    lab4_part2.s file in project window.
;
; 4. Fill in the missing source code in the interrupt service routine -
;    named "__AltIC6Interrupt". Refer to lab4_part2.s file in project
;    window.
;
; 5. Fill in the missing source code in this file (main.s).
;
; 6. Build the project, program the device and run.
;
; 7. Tweak the potentiometer, RP1, and observe the pulse width
;    output on the LCD
;
;..............................................................................
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab4.inc"             ;Lab-specific global equates
                                        ;Config Macros to program configuration
                                        ;words
                                        ;More example macros are provided in
                                        ;the device include file, p30f6014.inc
        config __FOSC, CSW_FSCM_OFF & XT_PLL8
        config __FWDT, WDT_OFF
        config __FBORPOR, PBOR_ON & BORV_20 & PWRT_OFF & MCLR_EN
        config __FGS, CODE_PROT_OFF
        
        .global _main
        .global PulseWidth, Frequency
        .global DisplayFlag

        .section .data
Frequency:      .hword 0x0000
PulseWidth:     .hword 0x0000
DisplayFlag:    .hword 0x0000

        .section .text                  ;Places source code in Code section


_main:                                  ;C-run-time library brings you here

        rcall   _SPI2_init              ;Initialize SPI2 and the LCD Controller
        rcall   _LCD_Controller_init

        rcall   lab4_init

        rcall   lab4_part1              ;Configure Input Capture for Frequecy
                                        ;measurement of PWM signal on pin RD13

        ; INSERT PART 2 CODE HERE       ;Call subroutine lab4_part2 to
                                        ;configure Input Capture for Pulse
                                        ;Width measurement of PWM signal on pin
                                        ;RD13

done:
        btsc    DisplayFlag, #0         ;Check if any new measurements have
                                        ;been made by the Input Capture
                                        ;module (DisplayFlag == 0xFFFF?)
        rcall   _UpdateLCDString        ;If so, call the LCD Update routine
                                        ;LCD is updated only when a new
                                        ;capture has occurred and the Timer1
                                        ;interrupt flag bit is set
        bra     done                    ;Loop endlessly to "done"




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        .end                                            ;EOF



