;START_HEADER
;
; dsPIC30F Training Source File, Revision 1.0
; (c) Copyright 2004 Microchip Technology, All rights reserved
;
; File Revision History:
; -----------------------------------------------------------------------------
; Rev.  MM/DD/YYYY   Details:                                           Who
; -----------------------------------------------------------------------------
; 1.0   06/30/2004   Lab Session for Masters 806 P30
;
;
; -----------------------------------------------------------------------------
;
; Software and Development Tools Info:
; -----------------------------------------------------------------------------
; Tool                          Version         Comments
; -----------------------------------------------------------------------------
; MPLAB IDE                     6.51            Required for development/ICD2
; MPLAB C30 Toolsuite           1.20.02         Required for assembler, linker
; dsPICDEM Board                1.1             Required hardware
; dsPIC30F6014 PIM              Rev B1/B2       Required processor
; -----------------------------------------------------------------------------
;
;
;
;
;..............................................................................
;END_HEADER
                                        ;Include definition files
        .include "p30fxxxx.inc"         ;Device specific SFR bit definitions
        .include "lab5.inc"             ;Lab-specific global equates

        .global _Copy_PM_String
        .section .text

_Copy_PM_String:
        push.d  w0                              ;Save w0-w2 on to stack
        push    w2
        push    CORCON                          ;Save CORCON onto stack


        mov     #psvpage(MyConstString), w0     ;Set up PSVPAG SFR using
        mov     w0, PSVPAG                      ;assembler operator "psvpage
                                                ;so that PSVPAG points to the
                                                ;page in which the string
                                                ;"MyConstString" is located

        mov     #psvoffset(MyConstString), w0   ;Set up w0 as a pointer to
                                                ;"MyConstString". This is done
                                                ;by initializing w0 with the
                                                ;offset from PSVPAG at which
                                                ;location "MyConstString" is
                                                ;located. Use assembler operator
                                                ;"psvoffset".

        bset    CORCON, #PSV                    ;Set the PSV bit in CORCON

        mov     #MyVarString, w1                ;Set up w1 as pointer to the
                                                ;destination string "MyVarString"

.if LAB5_PART1

;Perform the string copy
;Note that the source string is a null-terminated string

next_char:
        mov.b   [w0++], w2                      ;Read next character from
                                                ;MyConstString into w2

        cp0.b   w2                              ;Compare character in w2 to 0x0
                                                ;to check if the null termination
                                                ;character has been reached

        bra     z, end_str_copy                 ;If w2 = 0 jump to "end_str_copy"

        mov.b   w2, [w1++]                      ;Else copy character in w2 to next
                                                ;location pointed to by w1

        bra     next_char                       ;Branch to "next_char" to read
                                                ;next character from Program
                                                ;Memory
.endif

.if LAB5_PART2

;Perform the string copy assuming that exactly 13 characters exist
;in the source and destination strings. A check for the null-termination
;character is not required for this part of the lab.


        repeat  #12                             ;Read 13 characters from
        mov.b   [w0++], [w1++]                  ;MyConstString and copy to
                                                ;MyVarString in 2 instructions

.endif

end_str_copy:

        pop     CORCON                          ;Restore CORCON
        pop     w2                              ;Restore w0-w2
        pop.d   w0
        return                                  ;Return to calling routine


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                    ;
;                       Software License Agreement                   ;
;                                                                    ;
;   The software supplied herewith by Microchip Technology           ;
;   Incorporated (the "Company") for its dsPIC controller            ;
;   is intended and supplied to you, the Company's customer,         ;
;   for use solely and exclusively on Microchip dsPIC                ;
;   products. The software is owned by the Company and/or its        ;
;   supplier, and is protected under applicable copyright laws. All  ;
;   rights are reserved. Any use in violation of the foregoing       ;
;   restrictions may subject the user to criminal sanctions under    ;
;   applicable laws, as well as to civil liability for the breach of ;
;   the terms and conditions of this license.                        ;
;                                                                    ;
;   THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION.  NO           ;
;   WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING,    ;
;   BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND    ;
;   FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE     ;
;   COMPANY SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL,  ;
;   INCIDENTAL OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.  ;
;                                                                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.end                                    ;EOF

